package fw.action;

import fw.facade.Excep;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;

public abstract class ClassForm {

    private Hashtable<String, Parameter> parametres;
    private Hashtable<String, List<ClassForm>> llistes;
    private Hashtable<String, String> classeLlista;
    private Parameter lastParametre;

    public ClassForm() {
        parametres = new Hashtable<String, Parameter>();
        llistes = new Hashtable<String, List<ClassForm>>();
        classeLlista = new Hashtable<String, String>();
        lastParametre = null;


        NewResolJsp();
    }

    protected abstract void NewResolJsp();

    protected void addParametre(String s, String t) {
        lastParametre = new Parameter(t);
        parametres.put(s, lastParametre);
    }

   
    protected void addList(String n, String nc) {
        try {
            List<ClassForm> lcl = new ArrayList<ClassForm>();
            llistes.put(n, lcl);
             classeLlista.put(n, "tfc.example.classes." + nc);
        } catch (Exception e) {
            e.getMessage();
        }
    }

    public void setValor(String param, String valor) {
        if (parametres.containsKey(param)) {
            Parameter p = parametres.get(param);
            try {
                p.setValor(valor);
            } catch (Excep e) {
                e.getMessage();
            }
        }
    }

    public String getValor(String param) {
        if (parametres.containsKey(param)) {
            if (parametres.get(param) == null) {
                return null;
            } else {
                 return parametres.get(param).toString();

            }
        } else {
            return null;
        }
    }

   public Enumeration<String> getParameterK() {
        return parametres.keys();

    }

    public void setLlista(String nom, List<ClassForm> lc) {
        if (!lc.isEmpty()) {
            if (llistes.containsKey(nom)) {
                if (lc.get(0).getClass().getName().equalsIgnoreCase(classeLlista.get(nom))) {
                    llistes.put(nom, lc);
                }
            }
        }
    }

    public List<ClassForm> getLlista(String nom) {
        if (llistes.containsKey(nom)) {
            return llistes.get(nom);

        } else {
            return null;
        }
    }

   public Enumeration<String> getListK() {
        return llistes.keys();
    }
}
