package fw.action;

import java.util.Date;

import fw.facade.Excep;

public class Parameter {
	private Comparable parametre;
	private String tipus;

	
	public Parameter() {
		super();
		parametre = null;
		tipus = "";
	
	}

	public Parameter(String tipus) {
		super();
		this.parametre = null;
		this.tipus = tipus;
		
	}


	
	public void setValor(String s) throws Excep{
		try {
			if (tipus.equalsIgnoreCase("String")){
				parametre = s;
			}
			if (tipus.equalsIgnoreCase("Integer")){
				parametre = new Integer(s);
			}
			if (tipus.equalsIgnoreCase("Float")){
				parametre = new Float(s);
			}
			if (tipus.equalsIgnoreCase("Long")){
				parametre = new Long(s);
			}
			if (tipus.equalsIgnoreCase("Double")){
				parametre = new Double(s);
			}
			if (tipus.equalsIgnoreCase("Date")){
				parametre = new Date((new Integer(s.substring(0, 4))).intValue()-1900, (new Integer(s.substring(4, 6))).intValue()-1, (new Integer(s.substring(6, 8))).intValue());
			}
			if (tipus.equalsIgnoreCase("Boolean")){
				parametre = new Boolean(s);
			}

		}

catch (Exception e){
		e.getMessage();
		}
	}
	
	public String toString(){
		String valor = null;
		if (parametre!=null){
			if (tipus.equalsIgnoreCase("String")){
				valor = (String)parametre;
			}
			if (tipus.equalsIgnoreCase("Integer")){
				valor = ((Integer)parametre).toString();
			}
			if (tipus.equalsIgnoreCase("Float")){
				valor = ((Float)parametre).toString();
			}
			if (tipus.equalsIgnoreCase("Long")){
				valor = ((Long)parametre).toString();
			}
			if (tipus.equalsIgnoreCase("Double")){
				valor = ((Double)parametre).toString();
			}
			if (tipus.equalsIgnoreCase("Date")){
				String y = (new Integer(((Date)parametre).getYear()+1900)).toString(); 
				String m = (new Integer(((Date)parametre).getMonth()+1)).toString();
				if (m.length()==1){m = "0"+m;}
				String d = (new Integer(((Date)parametre).getDate())).toString();
				if (d.length()==1){d = "0"+d;}
				valor = d+"/"+m+"/"+y;
			}
			if (tipus.equalsIgnoreCase("Boolean")){
				valor = ((Boolean)parametre).toString();
			}
		}
		return valor;
	}
	
	public void clear(){
		parametre = null;
	}

}
