package fw.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.StringTokenizer;


import fw.action.mapAction;
import fw.action.ClassForm;

public class TableListTag extends TagSupport {
	
	private String nomLlista;
	private String border;
	private List<String> camps;

	
		public int doStartTag() {
			if (camps==null){camps=new ArrayList<String>();}
			ServletRequest request = pageContext.getRequest();
			mapAction jf = (mapAction)request.getAttribute("JspForm");
			if (jf != null) {
				List<ClassForm> llista = jf.getLlista(nomLlista);
				if (llista != null) {
					try {
						String underline = "";
						JspWriter out = pageContext.getOut();
						if (border == null){
							out.print("<table><TR>");
						} else {
							out.print("<table border=" + border +"><TR>");
						}
						for (Iterator<String> it = camps.iterator(); it.hasNext();){
							String v = it.next();
							underline = underline + "==========";
							out.print("<TD>&nbsp;&nbsp;"+v+"</TD>");
						}
						int numCamps = camps.size();
						
						out.print("</TR>");
						out.print("<TR><TD colspan=\""+numCamps+"\">"+underline+"</TD></TR>");
						if (llista.isEmpty()){
							out.print("<TR><TD colspan=\""+numCamps+"\" align=\"center\">No hi ha cap registre</TD></TR>");
						} else {
							for (Iterator<ClassForm> it=llista.iterator(); it.hasNext();){
								out.print("<TR>");
								ClassForm cl = it.next();
								for (Iterator<String> itc = camps.iterator(); itc.hasNext();){
									String v = cl.getValor(itc.next());
									out.print("<TD>"+v+"</TD>");
								}
								
								out.print("</TR>");
							}
						}
						out.print("</table>");
					} catch(Exception ioe) {
						System.out.println("Error construint TableListTag "+nomLlista+": " + ioe);
					}
					return(EVAL_BODY_INCLUDE);
				} else {
					System.out.println("Error construint TableListTag Llista "+nomLlista+" no existeix a request");
					return(SKIP_BODY);
				}
			} else {
				System.out.println("Error construint TableListTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public void setNomLlista(String nomLlista) {
			this.nomLlista = nomLlista;
		}		

		public void setBorder(String border) {
			this.border = border;
		}
		
		public void setCamps(String txCamps){
			camps = new ArrayList<String>();
			StringTokenizer st = new StringTokenizer(txCamps, ",");
			while (st.hasMoreElements()){
				camps.add(st.nextToken());
			}
			
		}
	/*public void setAction(String txFuncio){
			int i = txFuncio.indexOf("=");
			if (i!=-1){
				String nom = txFuncio.substring(0, i);
				int j = txFuncio.indexOf("(", i);
				if (j !=-1){
					//String funcio = txFuncio.substring(i+1, j);
					//if (txFuncio.endsWith(")")){
						//descFuncio1 = nom;
						//action = funcio;
						//campsFuncio1 = new ArrayList<String>();
						//StringTokenizer st = new StringTokenizer(txFuncio.substring(j+1, txFuncio.length()-1), ",");
						//while (st.hasMoreElements()){
						//	String v = st.nextToken();
						//	campsFuncio1.add(v);
					//	}
					//}
				}
			}			
		}*/


		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
