package fw.action;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import javax.servlet.ServletRequest;

public abstract class ActionForm extends ClassForm {

    private JspMap lastResolver;
    private List<JspMap> NewJspMap;

    public ActionForm() {
        super();

        lastResolver = null;

        NewJspMap = new ArrayList<JspMap>();
        NewJsp();
    }

    public void map(ServletRequest request) {
        for (Enumeration<String> par = super.getParameterK(); par.hasMoreElements();) {
            String param = par.nextElement();
            String valor = request.getParameter(param);
            if (valor != null) {
                super.setValor(param, valor);
            }
        }
    }

    protected abstract void NewResolJsp();

    protected abstract void NewJsp();

    protected void addJsp(String jsp) {
        lastResolver = new JspMap(jsp);
        NewJspMap.add(lastResolver);
    }

    public String resolJsp() {
        String jsp = null;
        int i = 0;
        while (jsp == null & i < NewJspMap.size()) {
            jsp = NewJspMap.get(i).result(this);
            i++;
        }
        return jsp;
    }
}
