package fw.facade;

import fw.action.mapAction;
import java.io.IOException;
import java.util.Hashtable;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;

public class FacesFilter extends AbstractFilter {

    private Hashtable<String, mapAction> Forms;

    public FacesFilter() {
        Forms = new Hashtable<String, mapAction>();
    }

    @Override
    public void PreFilter(ServletRequest request) throws IOException,
            ServletException {
        String idForm = request.getParameter("idForm");
        String nom = "tfc.example.jspForms." + idForm + "Form";
        super.setNetPage("/" + idForm + ".jsp");
        if (nom != null && Forms.containsKey(nom)) {
            request.setAttribute("JspForm", Forms.get(nom));
        } else {
            request.setAttribute("JspForm", null);
        }
    }

    @Override
    public void PostFilter(ServletRequest request) {
        mapAction form = (mapAction) request.getAttribute("JspForm");
        if (form != null) {
            String nom = form.getClass().getName();
            Forms.put(nom, form);
        }
    }
}
