package tfc.example;

import tfc.example.Data.InsteadDB;

public class Servlet {
  private InsteadDB service;
  private static Servlet instance;

  private Servlet() throws Exception{
  }
  
  public static final Servlet getInstance() {
	  if (instance==null) {
		  try {
			  instance = new Servlet();
		  } catch (Exception e) {
			  
		  }
		 	  
	  }
	  return instance;
  }

  public InsteadDB getInsteadDB () throws Exception {
    if (service == null) {
		try{
			service = new InsteadDB();
		}
		catch(Exception e){
			e.printStackTrace();
		}
    }
    return service;
  }
}
